#ifndef PUZZLE_H
#define PUZZLE_H
#include "config.h"

#define SAVEFILE "problem.txt"
#define TEXTFILE "result.txt"

typedef enum {
    dt_none = 0,
    dt_problem,   // Ϳ줿
    dt_fixed,     // ȤƳꤷ
    //    dt_reserved,  // ͽѤߤΥޥ
} digit_type_t;

typedef enum {
    ct_none    = 0,
    ct_focused,   // ʤߤʤɤܤƤޥ
    ct_forbidden, // ʤߤǰŪ˻ѤǤʤޥ
    ct_new,       // Ƚޥ
} cell_type_t;


typedef struct {
    int digit;
    cell_type_t ctype;
    digit_type_t dtype;
} cell_t;

// ǥԡǤ褦˹¤ηˤƤ
typedef struct {
    cell_t cell[9][9];
} area_t;

typedef struct {
    int digit_num[9];
    int digits_total;
    int digits_in_block[9];
    int digits_in_column[9];
    int digits_in_row[9];
} count_t;

typedef enum {
    ft_none, ft_block, ft_row, ft_column, ft_cell
} focus_type_t;

// solverܤƤս
typedef struct {
    focus_type_t type;
    int bn;
    int column;
    int row;
} focus_t;

#define n2bx(bn)   (bn % 3)
#define n2by(bn)   (bn / 3)
#define n2cx(bn, cn)   (bn%3*3 + cn%3)
#define n2cy(bn, cn)   (bn/3*3 + cn/3)
#define bxy2n(bx, by) (by*3+bx)
#define cxy2bn(cx, cy) (cy/3*3 + cx/3)
#define cxy2cn(cx, cy) ()

#define cxmin(bn) (n2cx(bn, 0))
#define cxmax(bn) (n2cx(bn, 2))
#define cymin(bn) (n2cy(bn, 0))
#define cymax(bn) (n2cy(bn, 6))

#define clear_bits(f) (f = 0)
#define set_digit_bits(f, digit) ((f) |= 1 << ((digit)-1))
#define set_bits(f, n) ((f) |= 1 << (n))
#define check_bits(f, n) ((f) & 1 << (n))
#define bit2n(f) (((f)==1)+((f)==2)*2+((f)==4)*3-1)
void clear_area(void);
void clear_counter(void);
void clear_focus(void);
void set_focus(focus_type_t type, int bn, int column, int row);
focus_type_t get_focus_type(void);
int get_focus_bn(void);
int get_focus_column(void);
int get_focus_row(void);

void clear_ctype(void);
int load_area(void);
int save_area(void);
int save_text(void);
void fline(FILE *fp);

int get_digit_by_cxy(int cx, int cy);
void set_digit_by_cxy(int cx, int cy, int digit);
cell_type_t get_ctype_by_cxy(int cx, int cy);
void set_ctype_by_cxy(int cx, int cy, cell_type_t type);
digit_type_t get_dtype_by_cxy(int cx, int cy);
void set_dtype_by_cxy(int cx, int cy, digit_type_t type);

int get_digit_by_cn(int bn, int cn);
void set_digit_by_cn(int bn, int cn, int digit);
cell_type_t get_ctype_by_cn(int bn, int cn);
void set_ctype_by_cn(int bn, int cn, cell_type_t type);
digit_type_t get_dtype_by_cn(int bn, int cn);
void set_dtype_by_cn(int bn, int cn, digit_type_t type);

int get_cn_in_block(int bn, int digit);
int get_cx_in_block(int bn, int digit);
int get_cy_in_block(int bn, int digit);
int get_cx_in_row(int row, int digit);
int get_cy_in_column(int column, int digit);


int get_free_cell_in_block(int bn);
int get_last_digit_in_block(int bn);
int get_free_cell_in_column(int column);
int get_last_digit_in_column(int column);
int get_free_cell_in_row(int row);
int get_last_digit_in_row(int row);
int get_full_column_in_block(int bn);
int get_full_row_in_block(int bn);

int get_digits_total(void);
int get_digit_num(int digit);
int get_digits_in_block(int bn);
int get_digits_in_column(int column);
int get_digits_in_row(int row);

int get_free_digit_in_bits(unsigned int bits);

void forbid_by_cxy(int cx, int cy);
void forbid_row_in_block(int bn, int cy);
void forbid_column_in_block(int bn, int cx);
void print_info(void);

#endif

