#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "puzzle.h"
#include "solver.h"
#include "main.h"

task_t task_stack[TASK_STACK_MAX];
int task_stack_top = 0;
int digits_total_on_empty;
int task_count;
task_phase_t task_phase;



void init_solver(void){
    printf("solver\n");
    clear_answer();
    //    check_digit = 1;
    //    check_bn = 0;
    task_stack_top = 0;
    // solverνƤӽФpush_basic_tasksetƤФ뤿
    digits_total_on_empty = -1;
    task_phase = tp_block;
    task_count = 0;
}

void clear_answer(void){
    int cx, cy;
    for (cy = 0 ; cy < 9 ; cy++){
        for (cx = 0 ; cx < 9 ; cx++){
            if (get_dtype_by_cxy(cx, cy) != dt_none &&
                get_dtype_by_cxy(cx, cy) != dt_problem)
            {
                set_digit_by_cxy(cx, cy, 0);
                set_dtype_by_cxy(cx, cy, dt_none);
            }
        }
    }
    clear_ctype();
    clear_focus();
}

task_t pop_task(void){
    task_t null_task = {tt_null, 0, 0};

    if (task_stack_top > 0){
        task_stack_top --;
        task_count ++;
        printf("pop:%d %d %d %d\n",
               task_stack[task_stack_top].type,
               task_stack[task_stack_top].bn,
               task_stack[task_stack_top].column,
               task_stack[task_stack_top].row
               );
        return task_stack[task_stack_top];
    }
    else {
        return null_task;
    }
}

void push_task(task_t task){
    if (task_stack_top < TASK_STACK_MAX){
        task_stack[task_stack_top] = task;
        task_stack_top ++;
    }
    else {
        printf("task stack overflow\n");
        exit(1);
    }
}

void push_basic_taskset(void){
    int bn, digit, cx, cy;
    task_t task;

    // ˤʤäƤ鹹ʤ硢֤Τå˥եܹ
    if (get_digits_total() == digits_total_on_empty){
        switch (task_phase){
        case tp_block:
            task_phase = tp_line;
            break;
        case tp_line:
            task_phase = tp_cell;
            break;
        case tp_cell:
            // tp_cellǹǤʤХ֥å
            return;
        default:
            assert(0);
        }

    }
    // äϥե᤹
    else {
        switch (task_phase){
        case tp_block:
            // 
            //            task_phase = tp_line;
            break;
        case tp_line:
            task_phase = tp_block;
            break;
        case tp_cell:
            task_phase = tp_block;
            break;
        default:
            assert(0);
        }
    }
    switch (task_phase){
    case tp_block:
        task.type = tt_digit_in_block;
        for (digit = 9 ; digit > 0 ; digit--){
            for (bn = 8 ; bn >= 0 ; bn--){
                task.bn = bn;
                task.column = -1;
                task.row = -1;
                task.digit = digit;
                push_task(task);
            }
        }
        break;
    case tp_line:
        task.type = tt_digit_in_column;
        for (digit = 9 ; digit > 0 ; digit--){
            for (cx = 8 ; cx >= 0 ; cx--){
                task.bn = -1;
                task.column = cx;
                task.row = -1;
                task.digit = digit;
                push_task(task);
            }
        }
        task.type = tt_digit_in_row;
        for (digit = 9 ; digit > 0 ; digit--){
            for (cy = 8 ; cy >= 0 ; cy--){
                task.bn = -1;
                task.column = -1;
                task.row = cy;
                task.digit = digit;
                push_task(task);
            }
        }
        break;
    case tp_cell:
        task.type = tt_digit_in_cell;
        for (cy = 8 ; cy >= 0 ; cy--){
            for (cx = 8 ; cx >= 0 ; cx--){
                task.bn = -1;
                task.column = cx;
                task.row = cy;
                push_task(task);
            }
        }
        break;
    default:
        assert(0);
    }
    digits_total_on_empty = get_digits_total();
}

void push_last_taskset(int bn, int cx, int cy){
    task_t task;
    task.type = tt_last_in_block;
    task.bn = bn;
    push_task(task);
    task.type = tt_last_in_column;
    task.column = cx;
    push_task(task);
    task.type = tt_last_in_row;
    task.row = cy;
    push_task(task);
}


solver_status_t solver(void){
    int bn, cn, cx, cy, digit;
    int bits;
    task_t task;
    static char message[1024]; // set_messageϥåʣʤstatic

    //    printf("%d %d\n", get_digits_total(), digits_total_on_empty);
    if (get_digits_total() == 9*9) return ss_complete;
    task = pop_task();
    if (task.type == tt_null){
        // åäܥåȤpushߤ
        // push˼Ԥ饮֥å
        push_basic_taskset();
        task = pop_task();
        if (task.type == tt_null) return ss_failure;
    }

    //    printf("%s\n", phase_name[phase]);
    clear_ctype();
    switch (task.type){
    case tt_digit_in_block:
        // digitȽƤ饹å
        if (get_digit_num(task.digit) == 9){
            task_count --;
            return ss_redo;
        } 
        // ֥ådigitȽƤ饹å
        if (get_cn_in_block(task.bn, task.digit) >= 0){
            printf("Ǥ˳\n");
            task_count --;
            return ss_redo;
        }
        printf("֥å%dο%dʤ...", task.bn, task.digit);
        sprintf(message, "֥å%1dο%dʤ",
                task.bn, task.digit);
        set_message(message);
        set_focus(ft_block, task.bn, -1, -1);
        printf("å\n");
        bits = get_forbidden_columns_for_block(task.bn, task.digit);
        printf("bits:%d\n", bits);
        for (cx = cxmin(task.bn) ; cx <= cxmax(task.bn) ; cx++){
            if (check_bits(bits, cx-cxmin(task.bn))){
                forbid_column_in_block(task.bn, cx);
            }
        }
        bits = get_forbidden_rows_for_block(task.bn, task.digit);
        printf("bits:%d\n", bits);
        for (cy = cymin(task.bn) ; cy <= cymax(task.bn) ; cy++){
            if (check_bits(bits, cy-cymin(task.bn))){
                forbid_row_in_block(task.bn, cy);
            }
        }
        return set_digit_to_unique_cell_in_block(task.bn, task.digit);
    case tt_digit_in_column:
        // digitȽƤ饹å
        if (get_digit_num(task.digit) == 9){
            task_count --;
            return ss_redo;
        } 
        // ֥ådigitȽƤ饹å
        if (get_cy_in_column(task.column, task.digit) >= 0){
            printf("Ǥ˳\n");
            task_count --;
            return ss_redo;
        }
        printf("%dο%dʤ...", task.column, task.digit);
        sprintf(message, "%1dο%dʤ",
                task.column, task.digit);
        set_message(message);
        set_focus(ft_column, -1, task.column, -1);
        printf("å\n");
        for (bn = cxy2bn(task.column, 0) ; bn <= cxy2bn(task.column, 8) ;
             bn += 3)
        {
            bits = get_forbidden_rows_for_block(bn, task.digit);
            printf("bits:%d\n", bits);
            for (cy = cymin(bn) ; cy <= cymax(bn) ; cy++){
                if (check_bits(bits, cy-cymin(bn))){
                    forbid_by_cxy(task.column, cy);
                }
            }
        }
        for (cy = 0 ; cy < 9 ; cy += 3){
            bn = cxy2bn(task.column, cy);
            cn = get_cn_in_block(bn, task.digit);
            if (cn >= 0){
                set_ctype_by_cn(bn, cn, ct_focused);
                forbid_column_in_block(bn, task.column);
            }
        }
        return set_digit_to_unique_cell_in_column(task.column, task.digit);
    case tt_digit_in_row:
        // digitȽƤ饹å
        if (get_digit_num(task.digit) == 9){
            task_count --;
            return ss_redo;
        } 
        // ֥ådigitȽƤ饹å
        if (get_cx_in_row(task.row, task.digit) >= 0){
            printf("Ǥ˳\n");
            task_count --;
            return ss_redo;
        }
        printf("%dο%dʤ...", task.row, task.digit);
        sprintf(message, "%1dο%dʤ",
                task.row, task.digit);
        set_message(message);
        set_focus(ft_row, -1, -1, task.row);
        printf("å\n");

        for (bn = cxy2bn(0, task.row) ; bn <= cxy2bn(8, task.row) ; bn++){
            bits = get_forbidden_columns_for_block(bn, task.digit);
            printf("bits:%d %d %d\n", bits, bn, cxmin(bn));
            for (cx = cxmin(bn) ; cx <= cxmax(bn) ; cx++){
                if (check_bits(bits, cx-cxmin(bn))){
                    forbid_by_cxy(cx, task.row);
                }
            }
        }
        for (cx = 0 ; cx < 9 ; cx += 3){
            bn = cxy2bn(cx, task.row);
            cn = get_cn_in_block(bn, task.digit);
            if (cn >= 0){
                set_ctype_by_cn(bn, cn, ct_focused);
                forbid_row_in_block(bn, task.row);
            }
        }
        return set_digit_to_unique_cell_in_row(task.row, task.digit);
    case tt_digit_in_cell:
        if (get_digit_by_cxy(task.column, task.row) != 0){
            task_count --;
            return ss_redo;
        } 
        printf("(%d,%d)ο...", task.column, task.row);
        sprintf(message, "(%1d,%1d)ο",
                    task.column, task.row);
            set_message(message);
            set_focus(ft_cell, -1, task.column, task.row);
        clear_bits(bits);
        for (cx = 0 ; cx < 9 ; cx ++){
            digit = get_digit_by_cxy(cx, task.row);
            if (digit > 0){
                set_digit_bits(bits, digit);
            }
        }
        for (cy = 0 ; cy < 9 ; cy ++){
            digit = get_digit_by_cxy(task.column, cy);
            if (digit > 0){
                set_digit_bits(bits, digit);
            }
        }
        for (cn = 0 ; cn < 9 ; cn ++){
            digit = get_digit_by_cn(cxy2bn(task.column, task.row), cn);
            if (digit > 0){
                set_digit_bits(bits, digit);
            }
        }
        digit = get_free_digit_in_bits(bits);
        if (digit != 0){
            set_digit_by_cxy(task.column, task.row, digit);
            set_dtype_by_cxy(task.column, task.row, dt_fixed);
            set_ctype_by_cxy(task.column, task.row, ct_new);
            return ss_found;
        }
        else {
            return ss_not_found;
        }
        break;
    case tt_last_in_block:
        set_focus(ft_block, task.bn, -1, -1);
        if (get_digits_in_block(task.bn) != 8){
            task_count --;
            return ss_redo;
        } 
        printf("֥å%dκǸο...", task.bn);
        sprintf(message, "֥å%1dκǸο", task.bn);
        set_message(message);
        digit = get_last_digit_in_block(task.bn);
        return set_digit_to_unique_cell_in_block(task.bn, digit);
    case tt_last_in_column:
        set_focus(ft_column, -1, task.column, -1);
        if (get_digits_in_column(task.column) != 8){
            task_count --;
            return ss_redo;
        } 
        printf("%dκǸο...", task.column);
        sprintf(message, "%1dκǸο", task.column);
        set_message(message);
        digit = get_last_digit_in_column(task.column);
        return set_digit_to_unique_cell_in_column(task.column, digit);
    case tt_last_in_row:
        set_focus(ft_row, -1, -1, task.row);
        if (get_digits_in_row(task.row) != 8){
            task_count --;
            return ss_redo;
        } 
        printf("%dκǸο...", task.row);
        sprintf(message, "%1dκǸο", task.row);
        set_message(message);
        digit = get_last_digit_in_row(task.row);
        return set_digit_to_unique_cell_in_row(task.row, digit);
    default:
        break;
    }
    return ss_not_found;
}

// digitͣζޥ(äƤ餺forbiddenǤʤ)
// 鿿֤
solver_status_t set_digit_to_unique_cell_in_block(int bn, int digit){
    int cn;
    cn = get_free_cell_in_block(bn);
    printf("set_digit_to_unique:digit:%d bn:%d cn:%d\n", digit, bn, cn);
    if (cn != -1){
        set_digit_by_cn(bn, cn, digit);
        set_dtype_by_cn(bn, cn, dt_fixed);
        set_ctype_by_cn(bn, cn, ct_new);
        push_last_taskset(bn, n2cx(bn, cn), n2cy(bn, cn));
        return ss_found;
    }
    return ss_not_found;
}
// digitͣζޥ(äƤ餺forbiddenǤʤ)
// 鿿֤
solver_status_t set_digit_to_unique_cell_in_column(int column, int digit){
    int cy;
    cy = get_free_cell_in_column(column);
    printf("set_digit_to_unique:digit:%d column:%d cy:%d\n", digit, column, cy);
    if (cy != -1){
        set_digit_by_cxy(column, cy, digit);
        set_dtype_by_cxy(column, cy, dt_fixed);
        set_ctype_by_cxy(column, cy, ct_new);
        push_last_taskset(cxy2bn(column, cy), column, cy);
        return ss_found;
    }
    return ss_not_found;
}
// digitͣζޥ(äƤ餺forbiddenǤʤ)
// 鿿֤
solver_status_t set_digit_to_unique_cell_in_row(int row, int digit){
    int cx;
    cx = get_free_cell_in_row(row);
    printf("set_digit_to_unique:digit:%d cx:%d row:%d\n", digit, cx, row);
    if (cx != -1){
        set_digit_by_cxy(cx, row, digit);
        set_dtype_by_cxy(cx, row, dt_fixed);
        set_ctype_by_cxy(cx, row, ct_new);
        push_last_taskset(cxy2bn(cx, row), cx, row);
        return ss_found;
    }
    return ss_not_found;
}
// ֥åtarget_bnФƱ֥å󤫤ˤdigit֤ʤ
// ̤3Υӥå֤ƥӥåȤ1ʤб֥åxɸ(0-2)ػ
int get_forbidden_columns_for_block(int target_bn, int digit){
    int i, bn, cn, cx, cy, digit_num = 0;
    int forbid_bits = 0, full_bits = 0, merge_bits = 0;
    for (i = 0 ; i < 3 ; i++){
        // bnƱå
        bn = bxy2n(n2bx(target_bn), i);
        if (bn == target_bn) continue;
        cn = get_cn_in_block(bn, digit);
        // digit¸ߤʤ餽ػ
        if (cn >= 0){
            set_ctype_by_cn(bn, cn, ct_focused);
            set_bits(forbid_bits, n2cx(bn, cn)-cxmin(bn));
            digit_num ++;
        }
        // digit¸ߤʤ硢ޤäƤå
        else {
            full_bits = get_full_column_in_block(bn);
            for (cx = cxmin(bn) ; cx <= cxmax(bn) ; cx++){
                if (check_bits(full_bits, cx-cxmin(bn))){
                    for (cy = cymin(bn) ; cy <= cymax(bn) ; cy++){
                        set_ctype_by_cxy(cx, cy, ct_focused);
                    }
                }

            }
            // 2ޤäƤĤ뤳ȤʤΤǤػ
            if (full_bits == 1+2 || full_bits == 1+4 || full_bits == 2+4){
                forbid_bits += 1+2+4-full_bits;
                // Υ֥ådigit󤬳ꤷƤΤ
                // digitȤƱˤ
                digit_num ++;
            }
            else {
                merge_bits |= full_bits;
            }
        }
    }
    // digitꡢ⤦ˤʤ
    // digit_num++ƤʤȤȤϡޤäƤ1ʲ
    if (digit_num == 1){
        merge_bits |= forbid_bits;
        if (merge_bits == 1+2 || merge_bits == 1+4 || merge_bits == 2+4){
            // digitΤȡޤäƤ󤬰ۤʤϡĤ
            // ԤΥ֥ådigit
            // ػ˲ä
            forbid_bits |= 1+2+4 - merge_bits;
        }
        // ʳξ(ޤäƤ󤬤ʤäƤdigitΤȰ)
        else {
            // ꤷʤΤǡػɲäϤʤ(digitΤΤ߶ػ)
        }
    }
    // ɤΥ֥ådigitʤ(ȤޤäƤ1ʲ)
    else if (digit_num == 0){
        // ꤷʤΤǡػɲäϤʤ(digitΤΤ߶ػ)
    }
    return forbid_bits;
}
int get_forbidden_rows_for_block(int target_bn, int digit){
    int i, bn, cn, cx, cy, digit_num = 0;
    int forbid_bits = 0, full_bits = 0, merge_bits = 0;
    for (i = 0 ; i < 3 ; i++){
        // bnƱԤå
        bn = bxy2n(i, n2by(target_bn));
        if (bn == target_bn) continue;
        cn = get_cn_in_block(bn, digit);
        // digit¸ߤʤ餽ιԤػ
        if (cn >= 0){
            set_ctype_by_cn(bn, cn, ct_focused);
            set_bits(forbid_bits, n2cy(bn, cn)-cymin(bn));
            digit_num ++;
        }
        // digit¸ߤʤ硢ޤäƤԤå
        else {
            full_bits = get_full_row_in_block(bn);
            for (cy = cymin(bn) ; cy <= cymax(bn) ; cy++){
                if (check_bits(full_bits, cy-cymin(bn))){
                    for (cx = cxmin(bn) ; cx <= cxmax(bn) ; cx++){
                        set_ctype_by_cxy(cx, cy, ct_focused);
                    }
                }

            }
            // 2ޤäƤĤιԤ뤳ȤʤΤǤιԤػ
            if (full_bits == 1+2 || full_bits == 1+4 || full_bits == 2+4){
                forbid_bits += 1+2+4-full_bits;
                // Υ֥ådigitιԤꤷƤΤ
                // digitȤƱˤ
                digit_num ++;
            }
            else {
                merge_bits |= full_bits;
            }
        }
    }
    // digitꡢ⤦ˤʤ
    // digit_num++ƤʤȤȤϡޤäƤԤ1԰ʲ
    if (digit_num == 1){
        merge_bits |= forbid_bits;
        if (merge_bits == 1+2 || merge_bits == 1+4 || merge_bits == 2+4){
            // digitΤԤȡޤäƤԤۤʤϡĤιԤ
            // ԤΥ֥ådigit
            // ػ߹Ԥ˲ä
            forbid_bits |= 1+2+4 - merge_bits;
        }
        // ʳξ(ޤäƤԤʤäƤdigitΤԤȰ)
        else {
            // ꤷʤΤǡػ߹ԤɲäϤʤ(digitΤԤΤ߶ػ߹)
        }
    }
    // ɤΥ֥ådigitʤ(ȤޤäƤԤ1԰ʲ)
    else if (digit_num == 0){
        // ꤷʤΤǡػɲäϤʤ(digitΤԤΤ߶ػ߹)
    }
    return forbid_bits;
}



int get_task_count(void){
    return task_count;
}
