#ifndef SOLVER_H
#define SOLVER_H
#include "config.h"

typedef enum {
    tt_begin = 0,
    tt_digit_in_block = 0,
    tt_digit_in_row,
    tt_digit_in_column,
    tt_last_in_block,
    tt_last_in_column,
    tt_last_in_row,
    tt_digit_in_cell,
    tt_null,
    tt_end
} task_type_t;

typedef enum {
    tp_block,
    tp_line,
    tp_cell,
} task_phase_t;

typedef struct {
    task_type_t type;
    int bn;
    int digit;
    int row;
    int column;
} task_t;

/*
typedef struct {
    int bn;
    int cx, cy;
} recent_set_t;
*/

#define TASK_STACK_MAX 1024

// solver()֤
// solverϸƤӽФȥļ¹Ԥ̤֤
typedef enum {
    ss_found,     // γ 
    ss_not_found, // γ˼
    ss_redo,      // Υ̵ƸƤӽФ׵
    ss_complete,  // ٤Ƥο
    ss_failure    // ͤޤ
} solver_status_t;



void init_solver(void);
void clear_answer(void);
task_t pop_task(void);
void push_task(task_t task);
void push_basic_taskset(void);
void push_last_taskset(int bn, int cx, int cy);
solver_status_t solver(void);
solver_status_t set_digit_to_unique_cell_in_block(int bn, int digit);
solver_status_t set_digit_to_unique_cell_in_column(int column, int digit);
solver_status_t set_digit_to_unique_cell_in_row(int row, int digit);
int get_forbidden_columns_for_block(int target_bn, int digit);
int get_forbidden_rows_for_block(int target_bn, int digit);
int get_task_count(void);
#endif
